moDraw.bestprice = {};

function moDraw.bestprice:setOpenPdaSlot(self, slot, slotName)	
	if moFillTypes == nil or moFillTypes[1] == nil then
		moGuiExtras:closeOpenSlot(self, slot, true, false);
		g_currentMission:showBlinkingWarning(tostring(moLanguageXml:getTxt("slotno")), 2500);
		return;
	end;
	moGeneralSettings.demandTimer = moGeneralSettings.demandTimer+1
	if moGeneralSettings.demandTimer > 400 then moGeneralSettings.demandTimer = 0;end;
	----
	--if moGuiMiniPdaSlots.values[slot].permUpdate then MultiOverlayV2:setSlotUpdate(self, slot);end;
	moGuiExtras:setSlotMaxProSwitch(self, slot);
	moGuiExtras:setSlotFirstEndObjects(self, slot);
	local firstObjectDisplay, endObjectDisplay = moGuiMiniPdaSlots.values[slot].firstObject, moGuiMiniPdaSlots.values[slot].endObject;
	local tempObjectDisplay = 0;
	----
	local farmSilo = moGeneralSettings.multiFarmSilo;
	local hotSpot = moGuiMiniPdaSlots.values[slot].hotSpot;
	if hotSpot then moGuiMiniPdaSlots.values[slot].clickArea.slotHotSpot = {};end;
	local posX = moGuiMiniPdaSlots.values[slot].openX+0.001;
	local posY = moGuiMiniPdaSlots.values[slot].openY;
	local size = moGuiMiniPdaSlots.values[slot].size;
	local distanceLine = moGuiMiniPdaSlots.values[slot].distanceLine;
	local widthSettings = moSetGetGui.buttonGfxWidth1*moSetGetGui.zoomOutInTemp*4;
	local heightSettings = moSetGetGui.buttonGfxHeight1*moSetGetGui.zoomOutInTemp*4;	
	local height = moSetGetGui.buttonGfxHeight1*(size*1000);
	local heightDefault = moSetGetGui.buttonGfxHeight1*(size*1000);
	local distanceDif = moGuiMiniPdaSlots.values[slot].distanceDif; --fillcontainer <----> filllevel
	local slotLength = moSetGetGui.buttonGfxWidth1*(size*1000/1.5)*(moGuiMiniPdaSlots.values[slot].length+moSetGetGui.screenAspectRatio);	
	local width = slotLength+distanceDif;	
	local widthNext = moSetGetGui.buttonGfxWidth1*(size*1000/1.5)*(moGeneralSettings.lengthStationName+moSetGetGui.screenAspectRatio)+widthSettings;
	local currentPosY = posY;
	function nextLine(setHeight, posYnew, setLine, posYline, widthLine, heightLine, onlyLine)
		if setLine then
			moSetGetGui:setOverlay(self, moSetGetGui["designLine"], posX-0.001, currentPosY-(posYline), widthLine, heightLine);
			moSetGetGui["designLine"]:render();
			if onlyLine then return;end;
		end;		
		if setHeight then height = height+(heightDefault)+posYnew;end; --height+size+posNew;
		currentPosY = currentPosY-(heightDefault)-posYnew; --posY-(size+posYnew);		
	end;	
	moSetGetGui["designGround".. slot]:render();
	setTextBold(true);	
	setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
	local sizeTemp = 0.010;
	if size < sizeTemp then sizeTemp = size;end;
	if moGuiMiniPdaSlots.keySwitchLast == slot then
		if not moGuiMiniPdaSlots.values[slot].settings then
			moSetGetGui["slotCfg"]:setPosition(posX, posY);
			moSetGetGui["slotCfg"]:render();
		else
			moSetGetGui["slotPos"]:setPosition(posX, posY);
			moSetGetGui["slotPos"]:render();
		end;
		nextLine(true, 0.005, false);
		moSetGetGui["slotFruit"]:setPosition(posX+(widthSettings*1), posY);
		moSetGetGui["slotFruit"]:render();		
		if not moGuiMiniPdaSlots.values[slot].seeInOutFruit then
			moSetGetGui["slotNotOkay"]:setPosition(posX+(widthSettings*1), posY);
			moSetGetGui["slotNotOkay"]:render();
		end;
		moSetGetGui["slotMoney"]:setPosition(posX+(widthSettings*2), posY);
		moSetGetGui["slotMoney"]:render();		
		if not moGuiMiniPdaSlots.values[slot].seePrice then
			moSetGetGui["slotNotOkay"]:setPosition(posX+(widthSettings*2), posY);
			moSetGetGui["slotNotOkay"]:render();
		end;
		moSetGetGui["slotPlus"]:setPosition(posX+(widthSettings*3), posY);
		moSetGetGui["slotPlus"]:render();		
		if moGuiMiniPdaSlots.values[slot].seeSmall then
			moSetGetGui["slotNotOkay"]:setPosition(posX+(widthSettings*3), posY);
			moSetGetGui["slotNotOkay"]:render();
		end;
		if not moGuiMiniPdaSlots.values[slot].hotSpot then
			moSetGetGui["slotHotSpot"]:setPosition(posX, posY-(heightSettings));
			moSetGetGui["slotHotSpot"]:render();
			moSetGetGui["slotNotOkay"]:setPosition(posX, posY-(heightSettings));
			moSetGetGui["slotNotOkay"]:render();
		else
			if moGuiMiniPdaSlots.isHotSpotObj then
				if moGuiMiniPdaSlots.hotSpotBlinkTemp <= moGuiMiniPdaSlots.hotSpotBlinkTime then --warningBlinkTime, warningBlinkTemp
					moGuiMiniPdaSlots.hotSpotBlinkTemp = moGuiMiniPdaSlots.hotSpotBlinkTemp+1			
					moSetGetGui["slotHotSpot"]:setPosition(posX, posY-(heightSettings));
					moSetGetGui["slotHotSpot"]:render();			
				else
					moGuiMiniPdaSlots.hotSpotBlinkTemp = moGuiMiniPdaSlots.hotSpotBlinkTemp+1
					if moGuiMiniPdaSlots.hotSpotBlinkTemp >= moGuiMiniPdaSlots.hotSpotBlinkTime*2 then moGuiMiniPdaSlots.hotSpotBlinkTemp = 0;end;
				end;
			else
				moSetGetGui["slotHotSpot"]:setPosition(posX, posY-(heightSettings));
				moSetGetGui["slotHotSpot"]:render();
			end;
		end;					
		moSetGetGui["slotSwitchL"]:setPosition(posX+(widthSettings*4), posY);
		moSetGetGui["slotSwitchL"]:render();
		renderText(posX+(widthSettings*4.7), posY+0.0035, sizeTemp, tostring(moGuiMiniPdaSlots.values[slot].switch));
		moSetGetGui["slotSwitchR"]:setPosition(posX+(widthSettings*5), posY);
		moSetGetGui["slotSwitchR"]:render();
		moSetGetGui["slotNextL"]:setPosition(posX+(widthSettings*6), posY);
		moSetGetGui["slotNextL"]:render();
		moSetGetGui["slotNextR"]:setPosition(posX+(widthSettings*8), posY);
		moSetGetGui["slotNextR"]:render();
		renderText(posX+(widthSettings*7.2), posY+0.0035, sizeTemp, tostring(moGuiMiniPdaSlots.values[slot].maxProSwitch));					
	else
		moSetGetGui["slotNotReady"]:setPosition(posX, posY-(heightSettings));
		moSetGetGui["slotNotReady"]:render();
		nextLine(true, 0.005, false);
		renderText(posX, posY+0.0035, sizeTemp, "Slotname:  ".. tostring(moGuiMiniPdaSlots.values[slot].name));
	end;	
	----
	local posTxt = "";
	--if moGeneralSettings.isTrainPrice then posTxt = "      ".. tostring(moLanguageXml:getTxt("train", nil, "Train")).. tostring(moLanguageXml:getTxt("price", nil, "price")).. " ".. tostring(moLanguageXml:getTxt("on", nil, "On"));end;
	renderText(posX+(widthSettings*1.1), currentPosY, size, tostring(moLanguageXml:getTxt("bestprices")).. ": ".. tostring(firstObjectDisplay).. "-".. tostring(endObjectDisplay));
	setTextAlignment(2);
	renderText(posX+width-distanceDif, currentPosY, size, tostring(moGuiMiniPdaSlots.values[slot].foundObjects));
	setTextAlignment(0);
	--renderText(posX+(widthSettings*1.1), currentPosY, size, tostring(moLanguageXml:getTxt("bestprices")).. ":");
	--renderText(posX+(widthSettings*2.1), currentPosY, size, tostring(moLanguageXml:getTxt("objects", nil, "Objects")).. ": ".. tostring(firstObjectDisplay).. "-".. tostring(endObjectDisplay));
	if moGeneralSettings.trainStationFound then
		setTextAlignment(0);	
		if moGeneralSettings.isTrainPrice then
			setTextColor(unpack(moGuiMiniPdaSlots.warningColor0));
			posTxt = tostring(moLanguageXml:getTxt("on", nil, "On"));
		else
			setTextColor(unpack(moGuiMiniPdaSlots.warningColor4));
			posTxt = tostring(moLanguageXml:getTxt("off", nil, "Off"));
		end;		
		renderText(posX+width-distanceDif, currentPosY, size, "   ".. tostring(moLanguageXml:getTxt("train", nil, "Train")).. tostring(moLanguageXml:getTxt("price", nil, "price")).. " ".. tostring(posTxt));
		setTextAlignment(0);
	end;
	nextLine(true, 0.007, true, 0.0035, width+widthNext, 0.001);
	----
	function setInternBestPrice(bestPrice, k)		
		local bestPriceTemp = string.format("%.1f", Utils.getNoNil(bestPrice,0));		
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
		setTextBold(true);
		setTextAlignment(0);
		local noAmount = false;
		if moFillTypes[k].siloAmount[farmSilo] ~= nil and moFillTypes[k].siloAmount[farmSilo] <= 1 then setTextColor(unpack(moGuiMiniPdaSlots.inactiveColor));noAmount = true;setTextBold(false);end;
		if string.find(moFillTypes[k].fruitName, "!") then
			setTextColor(unpack(moGuiMiniPdaSlots.warningColor3));
			if moPalFillTypes[k] ~= nil then
				moSetGetGui["palFruit"]:setPosition(posX+widthSettings, currentPosY-0.002);
				moSetGetGui["palFruit"]:render();
				renderText(posX+(widthSettings*2), currentPosY, size, "!".. moFillTypes[k].descName); ---old 0.232
			else
				renderText(posX+widthSettings, currentPosY, size, "!".. moFillTypes[k].descName); ---old 0.232
			end;
		else
			if moPalFillTypes[k] ~= nil then
				moSetGetGui["palFruit"]:setPosition(posX+widthSettings, currentPosY-0.002);
				moSetGetGui["palFruit"]:render();
				renderText(posX+(widthSettings*2), currentPosY, size, moFillTypes[k].fruitName);
			else
				renderText(posX+widthSettings, currentPosY, size, moFillTypes[k].fruitName);
			end;
		end;
		--ls 17
		--local pricePerLiterOld = string.format("%.4f", Utils.getNoNil(moFillTypes[k].previousHourPrice,0));
		--local pricePerLiter = string.format("%.4f", Utils.getNoNil(moFillTypes[k].pricePerLiter,0));
		local iconType = "Equal";
		--if moFillTypes[k].stateHourPrice == 1 then iconType = "Up";elseif moFillTypes[k].stateHourPrice == 2 then iconType = "Down";end;
		--if tonumber(pricePerLiterOld) < tonumber(pricePerLiter) then iconType = "Up";elseif tonumber(pricePerLiterOld) > tonumber(pricePerLiter) then iconType = "Down";end;
		if moStationes[moFillTypes[k].bestPriceStationDescName].tipTrigger.pricingDynamics[k]:getBaseCurveTrend() == PricingDynamics.TREND_FALLING then
			iconType = "Down";
		elseif moStationes[moFillTypes[k].bestPriceStationDescName].tipTrigger.pricingDynamics[k]:getBaseCurveTrend() == PricingDynamics.TREND_CLIMBING then
			iconType = "Up";		
		end;
		moSetGetGui["slotPrice".. iconType]:setPosition(posX, currentPosY-0.002);
		moSetGetGui["slotPrice".. iconType]:render();
		setTextBold(true);
		setTextAlignment(2);
		setTextColor(unpack(moGuiMiniPdaSlots.priceColor));
		local greatDemand = false;
		if moGeneralSettings.foundGreatDemand > 0 and moFillTypes[k].greatDemandStation ~= nil then setTextColor(unpack(moGuiMiniPdaSlots.demandColor));greatDemand = true;end;							
		if noAmount then setTextBold(false);end;
		if greatDemand then
			if moGeneralSettings.demandTimer > 200 then
				local demandMultiplier = string.format("%.1f", Utils.getNoNil(moFillTypes[k].greatDemandMultiplier,0));
				renderText(posX+width-distanceDif, currentPosY, size, "x".. tostring(demandMultiplier).. "(".. tostring(moStationes[moFillTypes[k].greatDemandStationDescName].greatDemandDuration).. "h)");
			else
				renderText(posX+width-distanceDif, currentPosY, size, bestPriceTemp);
			end;
		else
			renderText(posX+width-distanceDif, currentPosY, size, bestPriceTemp);
		end;
		setTextAlignment(3);
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));		
		if greatDemand then 
			renderText(posX+width, currentPosY, size, moFillTypes[k].greatDemandStation);
			if hotSpot then moDraw.bestprice:setClickAreaHotSpot(self, posX+width, currentPosY, widthNext, heightDefault, moFillTypes[k].x, moFillTypes[k].z, moFillTypes[k].greatDemandStation, slot);end;
		else
			renderText(posX+width, currentPosY, size, moFillTypes[k].bestPriceStation);
			if hotSpot then moDraw.bestprice:setClickAreaHotSpot(self, posX+width, currentPosY, widthNext, heightDefault, moFillTypes[k].x, moFillTypes[k].z, moFillTypes[k].bestPriceStation, slot);end;
		end;				
		nextLine(true, distanceLine, true, 0.0035, width+widthNext, 0.001);
	end;
	local bestPriceTotal = 0;
	local bestPriceTotalSwitch = 0;
	function setInternBestPriceTotal(bestPrice, k)		
		setTextAlignment(0);
		if moGuiMiniPdaSlots.values[slot].permUpdate then local emptyFruit = moSetGetAmount:getNoFoundSiloAmount(k);end;
		local bestPriceTemp = string.format("%.1f", Utils.getNoNil(bestPrice,0));		
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
		setTextBold(true);
		local noAmount = false;
		if moFillTypes[k].siloAmount[farmSilo] ~= nil then
			local foundAnimalsEmpty = false;
			if string.find(moGeneralSettings.foundAnimals, moFillTypes[k].descName.. " ") and moFillTypes[k].siloAmount[farmSilo] <= 0 then foundAnimalsEmpty = true;end;
			if moFillTypes[k].siloAmount[farmSilo] <= 1 or foundAnimalsEmpty then
				setTextColor(unpack(moGuiMiniPdaSlots.inactiveColor));
				setTextBold(false);
				bestPriceTemp = string.format("%.1f", 0.0);
				noAmount = true;
			else				
				local total = bestPrice*(tonumber(moFillTypes[k].siloAmount[farmSilo]/1000))/1000;
				if string.find(moGeneralSettings.foundAnimals, moFillTypes[k].descName.. " ") and moFillTypes[k].siloAmount[farmSilo] >= 1 then total = bestPrice*(tonumber(moFillTypes[k].siloAmount[farmSilo]/1000));end;
				bestPriceTotalSwitch = bestPriceTotalSwitch+total;
				bestPriceTemp = string.format("%.3f", total);
				bestPriceTemp = moGuiExtras:getMoneyFormat(bestPriceTemp);
			end;
		end;
		if string.find(moFillTypes[k].fruitName, "!") then
			setTextColor(unpack(moGuiMiniPdaSlots.warningColor3));
			if moPalFillTypes[k] ~= nil then
				moSetGetGui["palFruit"]:setPosition(posX+widthSettings, currentPosY-0.0025);
				moSetGetGui["palFruit"]:render();
				renderText(posX+(widthSettings*2), currentPosY, size, "!".. moFillTypes[k].descName);
			else
				renderText(posX+widthSettings, currentPosY, size, "!".. moFillTypes[k].descName); ---old 0.232
			end;
		else
			if moPalFillTypes[k] ~= nil then
				moSetGetGui["palFruit"]:setPosition(posX+widthSettings, currentPosY-0.0025);
				moSetGetGui["palFruit"]:render();
				renderText(posX+(widthSettings*2), currentPosY, size, moFillTypes[k].fruitName);
			else
				renderText(posX+widthSettings, currentPosY, size, moFillTypes[k].fruitName);
			end;
		end;
		--ls 17
		--local pricePerLiterOld = string.format("%.4f", Utils.getNoNil(moFillTypes[k].previousHourPrice,0));
		--local pricePerLiter = string.format("%.4f", Utils.getNoNil(moFillTypes[k].pricePerLiter,0));
		local iconType = "Equal";
		--if moFillTypes[k].stateHourPrice == 1 then iconType = "Up";elseif moFillTypes[k].stateHourPrice == 2 then iconType = "Down";end;
		if moStationes[moFillTypes[k].bestPriceStationDescName].tipTrigger.pricingDynamics[k]:getBaseCurveTrend() == PricingDynamics.TREND_FALLING then
			iconType = "Down";
		elseif moStationes[moFillTypes[k].bestPriceStationDescName].tipTrigger.pricingDynamics[k]:getBaseCurveTrend() == PricingDynamics.TREND_CLIMBING then
			iconType = "Up";		
		end;		
		--if tonumber(pricePerLiterOld) < tonumber(pricePerLiter) then iconType = "Up";elseif tonumber(pricePerLiterOld) > tonumber(pricePerLiter) then iconType = "Down";end;
		moSetGetGui["slotPrice".. iconType]:setPosition(posX, currentPosY-0.002);
		moSetGetGui["slotPrice".. iconType]:render();
		setTextBold(true);
		setTextAlignment(2);
		setTextColor(unpack(moGuiMiniPdaSlots.priceColor));
		local greatDemand = false;
		if moGeneralSettings.foundGreatDemand > 0 and moFillTypes[k].greatDemandStation ~= nil then setTextColor(unpack(moGuiMiniPdaSlots.demandColor));greatDemand = true;end;							
		if noAmount then setTextBold(false);end;
		if greatDemand then
			if moGeneralSettings.demandTimer > 200 then
				local demandMultiplier = string.format("%.1f", Utils.getNoNil(moFillTypes[k].greatDemandMultiplier,0));
				renderText(posX+width-distanceDif, currentPosY, size, "x".. tostring(demandMultiplier).. "(".. tostring(moStationes[moFillTypes[k].greatDemandStationDescName].greatDemandDuration).. "h)");
			else
				renderText(posX+width-distanceDif, currentPosY, size, bestPriceTemp.. " ".. tostring(moLanguageXml:getTxt("moneysymbol")));
			end;
		else
			renderText(posX+width-distanceDif, currentPosY, size, bestPriceTemp.. " ".. tostring(moLanguageXml:getTxt("moneysymbol")));
		end;
		setTextAlignment(3);
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));		
		if greatDemand then 
			renderText(posX+width, currentPosY, size, moFillTypes[k].greatDemandStation);
			if hotSpot then moDraw.bestprice:setClickAreaHotSpot(self, posX+width, currentPosY, widthNext, heightDefault, moFillTypes[k].x, moFillTypes[k].z, moFillTypes[k].greatDemandStation, slot);end;
		else
			renderText(posX+width, currentPosY, size, moFillTypes[k].bestPriceStation);
			if hotSpot then moDraw.bestprice:setClickAreaHotSpot(self, posX+width, currentPosY, widthNext, heightDefault, moFillTypes[k].x, moFillTypes[k].z, moFillTypes[k].bestPriceStation, slot);end;
		end;				
		nextLine(true, distanceLine, true, 0.0035, width+widthNext, 0.001);
	end;
	
	moSortBestPrice = {};	
	local count = 0;
	for k,v in pairs(moFillTypes) do			
		if FillUtil.fillTypeIndexToDesc[k].partOfEconomy ~= nil and FillUtil.fillTypeIndexToDesc[k].partOfEconomy or moFillTypes[k].descName == "silage" or string.len(moFillTypes[k].bestPriceStation) >= 2 then --or moFillTypes[k].descName == "wool" or moFillTypes[k].descName == "milk" or moFillTypes[k].descName == "egg" then
			--new fix straw grass windrow hay fuel double
			local doubleFound = false;
			if not moGeneralSettings.fruitsDoubleNames then
				if moFillTypes[k].fuel and moFillTypes[k].descName ~= tostring(moGeneralSettings.masterFuelFruit) then doubleFound = true;end;
				if moFillTypes[k].grass and moFillTypes[k].descName ~= tostring(moGeneralSettings.masterGrassFruit) then doubleFound = true;end;
				if moFillTypes[k].hay and moFillTypes[k].descName ~= tostring(moGeneralSettings.masterHayFruit) then doubleFound = true;end;
				if moFillTypes[k].windrow and moFillTypes[k].descName ~= tostring(moGeneralSettings.masterWindrowFruit) then doubleFound = true;end;
				if moFillTypes[k].kalk and moFillTypes[k].descName ~= tostring(moGeneralSettings.masterKalkFruit) then doubleFound = true;end;
				if moFillTypes[k].manure and moFillTypes[k].descName ~= tostring(moGeneralSettings.masterManureFruit) then doubleFound = true;end;
				if moFillTypes[k].liquid and moFillTypes[k].descName ~= tostring(moGeneralSettings.masterLiquidFruit) then doubleFound = true;end;
			end;
			if not doubleFound then
			--new fix straw grass windrow hay fuel double
				if string.len(moFillTypes[k].bestPriceStation) >= 2 then
					local bestPrice = 0;				
					if moFillTypes[k].greatDemandStationDescName ~= nil then
						bestPrice = g_i18n:formatNumber(moFillTypes[k].bestPrice)*moFillTypes[k].greatDemandMultiplier; --moFillTypes[k].pricePerLiter*moFillTypes[k].stationPriceMulti[moFillTypes[k].greatDemandStationDescName.. " PriceMulti"]*moGeneralSettings.difficultyMultiplier*moFillTypes[k].greatDemandMultiplier*1000;
					else					
						bestPrice = g_i18n:formatNumber(moFillTypes[k].bestPrice); --moFillTypes[k].pricePerLiter*moFillTypes[k].bestPrice*moGeneralSettings.difficultyMultiplier*moFillTypes[k].greatDemandMultiplier*1000;					
					end;
					if string.find(moGeneralSettings.foundAnimals, moFillTypes[k].descName.. " ") then					
						if moFillTypes[k].greatDemandStationDescName ~= nil then
							bestPrice = g_i18n:formatNumber(moFillTypes[k].bestPrice)*moFillTypes[k].greatDemandMultiplier; --moFillTypes[k].pricePerLiter/1000*moFillTypes[k].stationPriceMulti[moFillTypes[k].greatDemandStationDescName.. " PriceMulti"]*moGeneralSettings.difficultyMultiplier*moFillTypes[k].greatDemandMultiplier*1000;
						else						
							bestPrice = g_i18n:formatNumber(moFillTypes[k].bestPrice); --moFillTypes[k].pricePerLiter/1000*moFillTypes[k].bestPrice*moGeneralSettings.difficultyMultiplier*moFillTypes[k].greatDemandMultiplier*1000;						
						end;
					end;				
					--if string.find(moGeneralSettings.foundAnimals, moFillTypes[k].descName.. " ") or moFillTypes[k].descName == "beef" or moFillTypes[k].descName == "pig" or moFillTypes[k].descName == "chicken2" or moFillTypes[k].descName == "cow" or moFillTypes[k].descName == "sheep" or moFillTypes[k].descName == "chicken" then								
					--	bestPrice = moFillTypes[k].pricePerLiter/1000*moFillTypes[k].bestPrice*moGeneralSettings.difficultyMultiplier*moFillTypes[k].greatDemandMultiplier*1000;
					--end;
					--local bestPriceTemp = string.format("%.1f", Utils.getNoNil(bestPrice,0));				
					if moGuiMiniPdaSlots.values[slot].seePrice then
						count = count+1;					
						moSortBestPrice[count] = (bestPrice/1000).. ";".. k;					
					elseif moGuiMiniPdaSlots.values[slot].seeInOutFruit then				
						if firstObjectDisplay <= moGuiMiniPdaSlots.values[slot].foundObjects then
							tempObjectDisplay = tempObjectDisplay+1;
							if tempObjectDisplay >= tonumber(firstObjectDisplay) and tempObjectDisplay <= tonumber(endObjectDisplay) then								
								setInternBestPriceTotal(bestPrice, k);
							else
								if moFillTypes[k].siloAmount[farmSilo] ~= nil then
									local foundAnimalsEmpty = false;
									if string.find(moGeneralSettings.foundAnimals, moFillTypes[k].descName.. " ") and moFillTypes[k].siloAmount[farmSilo] <= 0 then foundAnimalsEmpty = true;end;
									if moFillTypes[k].siloAmount[farmSilo] <= 1 or foundAnimalsEmpty then										
									else				
										local total = bestPrice*(tonumber(moFillTypes[k].siloAmount[farmSilo]));
										if string.find(moGeneralSettings.foundAnimals, moFillTypes[k].descName.. " ") and moFillTypes[k].siloAmount[farmSilo] >= 1 then total = bestPrice*(tonumber(moFillTypes[k].siloAmount[farmSilo]));end;
										bestPriceTotal = bestPriceTotal+total;										
									end;
								end;
							end;							
						end;
					else
						if firstObjectDisplay <= moGuiMiniPdaSlots.values[slot].foundObjects then							
							tempObjectDisplay = tempObjectDisplay+1;
							if tempObjectDisplay >= tonumber(firstObjectDisplay) and tempObjectDisplay <= tonumber(endObjectDisplay) then						
								setInternBestPrice(bestPrice, k);
							end;							
						end;
					end;							
				end;
			end;
		end;
	end;
	if moGuiMiniPdaSlots.values[slot].seePrice and count > 0 then
		function comp(w1,w2)
			if w1 > w2 then
				return true
			end
		end		
		table.sort(moSortBestPrice, comp);		
		if firstObjectDisplay <= moGuiMiniPdaSlots.values[slot].foundObjects then
			for a=firstObjectDisplay, table.getn(moSortBestPrice) do
				local priceDesc = Utils.splitString(";", moSortBestPrice[a]);			
				if priceDesc ~= nil and priceDesc[1] ~= nil and priceDesc[2] ~= nil then
					if tonumber(a) > tonumber(endObjectDisplay) then break;end;
					setInternBestPrice(priceDesc[1]*1000, tonumber(priceDesc[2]));
				end;
			end;
		end;
	end;
	if moGuiMiniPdaSlots.values[slot].seeInOutFruit then		
		setTextBold(true);
		local bestPriceTempTotal = string.format("%.3f", bestPriceTotal+bestPriceTotalSwitch);
		bestPriceTempTotal = moGuiExtras:getMoneyFormat(bestPriceTempTotal);
		if tonumber(firstObjectDisplay) ~= 1 or tonumber(endObjectDisplay) ~= moGuiMiniPdaSlots.values[slot].foundObjects then
			local bestPriceTempTotalSwitch = string.format("%.3f", bestPriceTotalSwitch);
			bestPriceTempTotalSwitch = moGuiExtras:getMoneyFormat(bestPriceTempTotalSwitch);
			setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
			renderText(posX, currentPosY, size, "Switch:");
			setTextAlignment(3);
			setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
			renderText(posX+width-distanceDif, currentPosY, size, "~".. bestPriceTempTotalSwitch.. " ".. tostring(moLanguageXml:getTxt("moneysymbol")));
			setTextAlignment(0);
			nextLine(true, distanceLine, true, 0.0035, width+widthNext, 0.001);
		end;
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
		renderText(posX, currentPosY, size, "Total:");
		setTextAlignment(3);
		setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
		renderText(posX+width-distanceDif, currentPosY, size, "~".. bestPriceTempTotal.. " ".. tostring(moLanguageXml:getTxt("moneysymbol")));
		setTextAlignment(0);		
		nextLine(true, distanceLine, true, 0.0035, width+widthNext, 0.001);
	end;
	----	
	moSetGetGui:setOverlay(self, moSetGetGui["designGround".. slot], posX-0.001, currentPosY+(heightSettings/2), width+widthNext, height+(heightSettings/2)); --+heightSettings	
	moGuiMiniPdaSlots.values[slot].openLastWidth = width+widthNext;
	moGuiMiniPdaSlots.values[slot].openLastHeight = height+(heightSettings/2); --+heightSettings	
	setTextColor(1, 1, 1, 1);
	setTextAlignment(0);
	setTextBold(false);	
end;

function moDraw.bestprice:setClickAreaHotSpot(self, posX, posY, horizontal, vertical, objX, objZ, name, slot)	
	if objX == nil or objZ == nil then return;end;
	local a = Utils.getNoNil(table.getn(moGuiMiniPdaSlots.values[slot].clickArea.slotHotSpot), 0);	
	moGuiMiniPdaSlots.values[slot].clickArea.slotHotSpot[a+1] = {posX, posX+(horizontal), posY, posY+(vertical), objX, objZ, name };
end;